## Introduction

Go is an open source project, distributed under a BSD-style license. This document explains how to check out the sources, build them on your own machine, and run them.

Most users don't need to do this, and will instead install from precompiled binary packages as described in Getting Started, a much simpler process. If you want to help develop what goes into those precompiled packages, though, read on.

There are two official Go compiler toolchains. This document focuses on the `gc` Go compiler and tools. For information on how to work on `gccgo`, a more traditional compiler using the GCC back end, see Setting up and using gccgo.

The Go compilers support nine instruction sets. There are important differences in the quality of the compilers for the different architectures.

`amd64` (also known as `x86-64`)
  A mature implementation.
`386` (`x86` or `x86-32`)
  Comparable to the `amd64` port.
`arm` (`ARM`)
  Supports Linux, FreeBSD, NetBSD, OpenBSD and Darwin binaries. Less widely used than the other ports.
`arm64` (`AArch64`)
  Supports Linux and Darwin binaries. New in 1.5 and not as well exercised as other ports.
`ppc64, ppc64le` (64-bit PowerPC big- and little-endian)
  Supports Linux binaries. New in 1.5 and not as well exercised as other ports.
`mips, mipsle` (32-bit MIPS big- and little-endian)
  Supports Linux binaries. New in 1.8 and not as well exercised as other ports.
`mips64, mips64le` (64-bit MIPS big- and little-endian)
  Supports Linux binaries. New in 1.6 and not as well exercised as other ports.
`s390x` (IBM System z)
  Supports Linux binaries. New in 1.7 and not as well exercised as other ports.
`wasm` (WebAssembly)
  Targets the WebAssembly platform. New in 1.11 and not as well exercised as other ports.

Except for things like low-level operating system interface code, the run-time support is the same in all ports and includes a mark-and-sweep garbage collector, efficient array and string slicing, and support for efficient goroutines, such as stacks that grow and shrink on demand.

The compilers can target the DragonFly BSD, FreeBSD, Linux, NetBSD, OpenBSD, macOS (Darwin), Plan 9, Solaris and Windows operating systems. The full set of supported combinations is listed in the discussion of environment variables below.

See the main installation page for the overall system requirements. The following additional constraints apply to systems that can be built only from source:

- For Linux on PowerPC 64-bit, the minimum supported kernel version is 2.6.37, meaning that Go does not support CentOS 6 on these systems.

## Install Go compiler binaries

The Go toolchain is written in Go. To build it, you need a Go compiler installed. The scripts that do the initial build of the tools look for an existing Go tool chain in `$GOROOT_BOOTSTRAP`. If unset, the default value of `GOROOT_BOOTSTRAP` is `$HOME/go1.4`.

There are many options for the bootstrap toolchain. After obtaining one, set `GOROOT_BOOTSTRAP` to the directory containing the unpacked tree. For example, `$GOROOT_BOOTSTRAP/bin/go` should be the `go` command binary for the bootstrap toolchain.

### Bootstrap toolchain from binary release

To use a binary release as a bootstrap toolchain, see the downloads page or use any other packaged Go distribution.

### Bootstrap toolchain from source

To build a bootstrap toolchain from source, use either the git branch `release-branch.go1.4` or go1.4-bootstrap-20171003.tar.gz, which contains the Go 1.4 source code plus accumulated fixes to keep the tools running on newer operating systems. (Go 1.4 was the last distribution in which the toolchain was written in C.) After unpacking the Go 1.4 source, `cd` to the `src` subdirectory, set `CGO_ENABLED=0` in the environment, and run `make.bash` (or, on Windows, `make.bat`).

Once the Go 1.4 source has been unpacked into your GOROOT_BOOTSTRAP directory, you must keep this git clone instance checked out to branch `release-branch.go1.4`. Specifically, do not attempt to reuse this git clone in the later step named "Fetch the repository." The go1.4 bootstrap toolchain must be able to properly traverse the go1.4 sources that it assumes are present under this repository root.

### Bootstrap toolchain from cross-compiled source

To cross-compile a bootstrap toolchain from source, which is necessary on systems Go 1.4 did not target (for example, `linux/ppc64le`), install Go on a different system and run bootstrap.bash.

When run as (for example)

    $ GOOS=linux GOARCH=ppc64 ./bootstrap.bash

`bootstrap.bash` cross-compiles a toolchain for that `GOOS/GOARCH` combination, leaving the resulting tree in `../../go-${GOOS}-${GOARCH}-bootstrap`. That tree can be copied to a machine of the given target type and used as `GOROOT_BOOTSTRAP` to bootstrap a local build.

### Bootstrap toolchain using gccgo

To use gccgo as the bootstrap toolchain, you need to arrange for `$GOROOT_BOOTSTRAP/bin/go` to be the go tool that comes as part of gccgo 5. For example on Ubuntu Vivid:

    $ sudo apt-get install gccgo-5
    $ sudo update-alternatives --set go /usr/bin/go-5
    $ GOROOT_BOOTSTRAP=/usr ./make.bash

## Install Git, if needed

To perform the next step you must have Git installed. (Check that you have a `git` command before proceeding.)

If you do not have a working Git installation, follow the instructions on the Git downloads page.

## (Optional) Install a C compiler

To build a Go installation with `cgo` support, which permits Go programs to import C libraries, a C compiler such as `gcc` or `clang` must be installed first. Do this using whatever installation method is standard on the system.

To build without `cgo`, set the environment variable `CGO_ENABLED=0` before running `all.bash` or `make.bash`.

## Fetch the repository

Change to the directory where you intend to install Go, and make sure the `goroot` directory does not exist. Then clone the repository and check out the latest release tag (`go1.12`, for example):

    $ git clone https://go.googlesource.com/go goroot
    $ cd goroot
    $ git checkout <tag>

Where `<tag>` is the version string of the release.

Go will be installed in the directory where it is checked out. For example, if Go is checked out in `$HOME/goroot`, executables will be installed in `$HOME/goroot/bin`. The directory may have any name, but note that if Go is checked out in `$HOME/go`, it will conflict with the default location of `$GOPATH`. See `GOPATH` below.

Reminder: If you opted to also compile the bootstrap binaries from source (in an earlier section), you still need to `git clone` again at this point (to checkout the latest `<tag>`), because you must keep your go1.4 repository distinct.

## (Optional) Switch to the master branch

If you intend to modify the go source code, and contribute your changes to the project, then move your repository off the release branch, and onto the master (development) branch. Otherwise, skip this step.

    $ git checkout master

## Install Go

To build the Go distribution, run

    $ cd src
    $ ./all.bash

(To build under Windows use `all.bat`.)

If all goes well, it will finish by printing output like:

    ALL TESTS PASSED

    ---
    Installed Go for linux/amd64 in /home/you/go.
    Installed commands in /home/you/go/bin.
    *** You need to add /home/you/go/bin to your $PATH. ***

where the details on the last few lines reflect the operating system, architecture, and root directory used during the install.

For more information about ways to control the build, see the discussion of environment variables below. `all.bash` (or `all.bat`) runs important tests for Go, which can take more time than simply building Go. If you do not want to run the test suite use `make.bash` (or `make.bat`) instead.

## Testing your installation

Check that Go is installed correctly by building a simple program.

Create a file named `hello.go` and put the following program in it:

    package main

    import "fmt"

    func main() {
    	fmt.Printf("hello, world\n")
    }

Then run it with the `go` tool:

    $ go run hello.go
    hello, world

If you see the "hello, world" message then Go is installed correctly.

## Set up your work environment

You're almost done. You just need to do a little more setup.

How to Write Go Code Learn how to set up and use the Go tools

The How to Write Go Code document provides essential setup instructions for using the Go tools.

## Install additional tools

The source code for several Go tools (including godoc) is kept in the go.tools repository. To install one of the tools (`godoc` in this case):

    $ go get golang.org/x/tools/cmd/godoc

To install these tools, the `go` `get` command requires that Git be installed locally.

You must also have a workspace (`GOPATH`) set up; see How to Write Go Code for the details.

## Community resources

The usual community resources such as `#go-nuts` on the Freenode IRC server and the Go Nuts mailing list have active developers that can help you with problems with your installation or your development work. For those who wish to keep up to date, there is another mailing list, golang-checkins, that receives a message summarizing each checkin to the Go repository.

Bugs can be reported using the Go issue tracker.

## Keeping up with releases

New releases are announced on the golang-announce mailing list. Each announcement mentions the latest release tag, for instance, `go1.9`.

To update an existing tree to the latest release, you can run:

    $ cd go/src
    $ git fetch
    $ git checkout <tag></psan>
    $ ./all.bash

Where `<tag>` is the version string of the release.

## Optional environment variables

The Go compilation environment can be customized by environment variables. None is required by the build, but you may wish to set some to override the defaults.

- `$GOROOT`

  The root of the Go tree, often `$HOME/go1.X`. Its value is built into the tree when it is compiled, and defaults to the parent of the directory where `all.bash` was run. There is no need to set this unless you want to switch between multiple local copies of the repository.

- `$GOROOT_FINAL`

  The value assumed by installed binaries and scripts when `$GOROOT` is not set explicitly. It defaults to the value of `$GOROOT`. If you want to build the Go tree in one location but move it elsewhere after the build, set `$GOROOT_FINAL` to the eventual location.

- `$GOPATH`

  The directory where Go projects outside the Go distribution are typically checked out. For example, `golang.org/x/tools` might be checked out to `$GOPATH/src/golang.org/x/tools`. Executables outside the Go distribution are installed in `$GOPATH/bin` (or `$GOBIN`, if set). Modules are downloaded and cached in `$GOPATH/pkg/mod`.

  The default location of `$GOPATH` is `$HOME/go`, and it's not usually necessary to set `GOPATH` explicitly. However, if you have checked out the Go distribution to `$HOME/go`, you must set `GOPATH` to another location to avoid conflicts.

- `$GOBIN`

  The directory where executables outside the Go distribution are installed using the go command. For example, `go get golang.org/x/tools/cmd/godoc` downloads, builds, and installs `$GOBIN/godoc`. By default, `$GOBIN` is `$GOPATH/bin` (or `$HOME/go/bin` if `GOPATH` is not set). After installing, you will want to add this directory to your `$PATH` so you can use installed tools.

  Note that the Go distribution's executables are installed in `$GOROOT/bin` (for executables invoked by people) or `$GOTOOLDIR` (for executables invoked by the go command; defaults to `$GOROOT/pkg/$GOOS_GOARCH`) instead of `$GOBIN`.

- `$GOOS` and `$GOARCH`

  The name of the target operating system and compilation architecture. These default to the values of `$GOHOSTOS` and `$GOHOSTARCH` respectively (described below).

Choices for `$GOOS` are `android`, `darwin` (macOS 10.11 and above and iOS), `dragonfly`, `freebsd`, `illumos`, `js`, `linux`, `netbsd`, `openbsd`, `plan9`, `solaris` and `windows`.

Choices for `$GOARCH` are `amd64` (64-bit x86, the most mature port), `386` (32-bit x86), `arm` (32-bit ARM), `arm64` (64-bit ARM), `ppc64le` (PowerPC 64-bit, little-endian), `ppc64` (PowerPC 64-bit, big-endian), `mips64le` (MIPS 64-bit, little-endian), `mips64` (MIPS 64-bit, big-endian), `mipsle` (MIPS 32-bit, little-endian), `mips` (MIPS 32-bit, big-endian), `s390x` (IBM System z 64-bit, big-endian), and `wasm` (WebAssembly 32-bit).

The valid combinations of `$GOOS` and `$GOARCH` are:

| `$GOOS` | `$GOARCH`
--- | --- | ---
| `aix` | `ppc64`
| `android` | `386`
| `android` | `amd64`
| `android` | `arm`
| `android` | `arm64`
| `darwin` | `386`
| `darwin` | `amd64`
| `darwin` | `arm`
| `darwin` | `arm64`
| `dragonfly` | `amd64`
| `freebsd` | `386`
| `freebsd` | `amd64`
| `freebsd` | `arm`
| `illumos` | `amd64`
| `js` | `wasm`
| `linux` | `386`
| `linux` | `amd64`
| `linux` | `arm`
| `linux` | `arm64`
| `linux` | `ppc64`
| `linux` | `ppc64le`
| `linux` | `mips`
| `linux` | `mipsle`
| `linux` | `mips64`
| `linux` | `mips64le`
| `linux` | `s390x`
| `netbsd` | `386`
| `netbsd` | `amd64`
| `netbsd` | `arm`
| `openbsd` | `386`
| `openbsd` | `amd64`
| `openbsd` | `arm`
| `openbsd` | `arm64`
| `plan9` | `386`
| `plan9` | `amd64`
| `plan9` | `arm`
| `solaris` | `amd64`
| `windows` | `386`
| `windows` | `amd64`

- `$GOHOSTOS` and `$GOHOSTARCH`

  The name of the host operating system and compilation architecture. These default to the local system's operating system and architecture.

Valid choices are the same as for `$GOOS` and `$GOARCH`, listed above. The specified values must be compatible with the local system. For example, you should not set `$GOHOSTARCH` to `arm` on an x86 system.

- `$GO386` (for `386` only, default is auto-detected if built on either `386` or `amd64`, `387` otherwise)

  This controls the code generated by gc to use either the 387 floating-point unit (set to `387`) or SSE2 instructions (set to `sse2`) for floating point computations.

  - `GO386=387`: use x87 for floating point operations; should support all x86 chips (Pentium MMX or later).
  - `GO386=sse2`: use SSE2 for floating point operations; has better performance than 387, but only available on Pentium 4/Opteron/Athlon 64 or later.
- `$GOARM` (for `arm` only; default is auto-detected if building on the target processor, 6 if not)

  This sets the ARM floating point co-processor architecture version the run-time should target. If you are compiling on the target system, its value will be auto-detected.

  - `GOARM=5`: use software floating point; when CPU doesn't have VFP co-processor
  - `GOARM=6`: use VFPv1 only; default if cross compiling; usually ARM11 or better cores (VFPv2 or better is also supported)
  - `GOARM=7`: use VFPv3; usually Cortex-A cores

  If in doubt, leave this variable unset, and adjust it if required when you first run the Go executable. The GoARM page on the Go community wiki contains further details regarding Go's ARM support.

- `$GOMIPS` (for `mips` and `mipsle` only)
  `$GOMIPS64` (for `mips64` and `mips64le` only)

  These variables set whether to use floating point instructions. Set to "`hardfloat`" to use floating point instructions; this is the default. Set to "`softfloat`" to use soft floating point.

- `$GOPPC64` (for `ppc64` and `ppc64le` only)

  This variable sets the processor level (i.e. Instruction Set Architecture version) for which the compiler will target. The default is `power8`.

  - `GOPPC64=power8`: generate ISA v2.07 instructions
  - `GOPPC64=power9`: generate ISA v3.00 instructions
- `$GOWASM` (for `wasm` only)

  This variable is a comma separated list of experimental WebAssembly features that the compiled WebAssembly binary is allowed to use. The default is to use no experimental features.

  - `GOWASM=satconv`: generate saturating (non-trapping) float-to-int conversions
  - `GOWASM=signext`: generate sign-extension operators

Note that `$GOARCH` and `$GOOS` identify the target environment, not the environment you are running on. In effect, you are always cross-compiling. By architecture, we mean the kind of binaries that the target environment can run: an x86-64 system running a 32-bit-only operating system must set `GOARCH` to `386`, not `amd64`.

If you choose to override the defaults, set these variables in your shell profile (`$HOME/.bashrc`, `$HOME/.profile`, or equivalent). The settings might look something like this:

    export GOARCH=amd64
    export GOOS=linux

although, to reiterate, none of these variables needs to be set to build, install, and develop the Go tree.